"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _intlReact = require("@cloudflare/intl-react");

var _componentTextarea = require("@cloudflare/component-textarea");

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var Textarea = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme;
  return {
    height: '7rem',
    wordBreak: 'break-all',
    cursor: 'text',
    resize: 'none',
    color: theme.colors.gray[1],
    fontFamily: 'monaco, courier, monospace'
  };
}, _componentTextarea.Textarea);

var styles = function styles() {
  return {
    mt: 3,
    cursor: 'pointer'
  };
};

var HelpText = (0, _styleContainer.createComponent)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    fontSize: theme.fontSizes[2],
    color: theme.colors.gray[2],
    marginTop: theme.space[2],
    marginBottom: theme.space[3]
  };
}, 'p');

var CopyableTextarea = function CopyableTextarea(_ref3) {
  var name = _ref3.name,
      _ref3$value = _ref3.value,
      value = _ref3$value === void 0 ? '' : _ref3$value,
      onCopy = _ref3.onCopy,
      className = _ref3.className,
      _ref3$clickToCopyText = _ref3.clickToCopyText,
      clickToCopyText = _ref3$clickToCopyText === void 0 ? 'Click here to copy' : _ref3$clickToCopyText,
      _ref3$copiedTextToCli = _ref3.copiedTextToClipboardText,
      copiedTextToClipboardText = _ref3$copiedTextToCli === void 0 ? 'Copied text to clipboard' : _ref3$copiedTextToCli,
      _ref3$pressCommandOrC = _ref3.pressCommandOrCtrlCToCopyText,
      pressCommandOrCtrlCToCopyText = _ref3$pressCommandOrC === void 0 ? 'Press Command/Ctrl+C to copy' : _ref3$pressCommandOrC,
      _ref3$clickToCopyText2 = _ref3.clickToCopyTextId,
      clickToCopyTextId = _ref3$clickToCopyText2 === void 0 ? 'common.click_to_copy' : _ref3$clickToCopyText2,
      _ref3$copiedTextToCli2 = _ref3.copiedTextToClipboardTextId,
      copiedTextToClipboardTextId = _ref3$copiedTextToCli2 === void 0 ? 'common.copied_to_clipboard' : _ref3$copiedTextToCli2,
      _ref3$pressCommandOrC2 = _ref3.pressCommandOrCtrlCToCopyTextId,
      pressCommandOrCtrlCToCopyTextId = _ref3$pressCommandOrC2 === void 0 ? 'common.copy_failed' : _ref3$pressCommandOrC2;

  var _useState = (0, _react.useState)('init'),
      _useState2 = _slicedToArray(_useState, 2),
      copyState = _useState2[0],
      setCopyState = _useState2[1];

  var textarea = (0, _react.useRef)(null);
  var helpTextId = {
    init: clickToCopyTextId,
    successed: copiedTextToClipboardTextId,
    failed: pressCommandOrCtrlCToCopyTextId
  };
  var fallbackHelpText = {
    init: clickToCopyText,
    successed: copiedTextToClipboardText,
    failed: pressCommandOrCtrlCToCopyText
  };

  var handleFocus = function handleFocus() {
    textarea.current && textarea.current.select();
    var success = false;

    try {
      success = document.execCommand('copy');
    } catch (err) {
      success = false;
    }

    if (success && onCopy) {
      onCopy();
    }

    setCopyState(success ? 'successed' : 'failed');
  };

  var handleBlur = function handleBlur() {
    setCopyState('init');
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: className
  }, /*#__PURE__*/_react.default.createElement(Textarea, {
    innerRef: textarea,
    readOnly: true,
    name: name,
    value: value,
    onFocus: handleFocus,
    onBlur: handleBlur
  }), /*#__PURE__*/_react.default.createElement(HelpText, {
    onClick: handleFocus
  }, /*#__PURE__*/_react.default.createElement(_intlReact.Trans, {
    id: helpTextId[copyState],
    _: fallbackHelpText[copyState]
  })));
};

CopyableTextarea.propTypes = {
  className: _propTypes.default.string,
  name: _propTypes.default.string.isRequired,
  value: _propTypes.default.string.isRequired,
  onCopy: _propTypes.default.func,
  clickToCopyText: _propTypes.default.string,
  copiedTextToClipboardText: _propTypes.default.string,
  pressCommandOrCtrlCToCopyText: _propTypes.default.string,
  clickToCopyTextId: _propTypes.default.string,
  copiedTextToClipboardTextId: _propTypes.default.string,
  pressCommandOrCtrlCToCopyTextId: _propTypes.default.string
};
CopyableTextarea.displayName = 'CopyableTextare';

var _default = (0, _styleContainer.createStyledComponent)(styles, CopyableTextarea);

exports.default = _default;